package gregapi.block;

import gregapi.data.CS.ModIDs;

import java.util.List;

import cpw.mods.fml.common.Optional;

import micdoodle8.mods.galacticraft.api.block.IPartialSealableBlock;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

/**
 * @author Gregorius Techneticies
 */
@Optional.InterfaceList(value = {
	@Optional.Interface(iface = "micdoodle8.mods.galacticraft.api.block.IPartialSealableBlock", modid = ModIDs.GC)
})
public interface IBlockBase extends IPartialSealableBlock {
	public String name(int aMeta);
	public boolean useGravity(int aMeta);
	public boolean doesWalkSpeed(short aMeta);
	public boolean canCreatureSpawn(int aMeta);
	public boolean isSealable(int aMeta, byte aSide);
	public void addInformation(ItemStack aStack, int aMeta, EntityPlayer aPlayer, List aList, boolean aF3_H);
	public float getExplosionResistance(int aMeta);
	public int getItemStackLimit(ItemStack aStack);
	public ItemStack onItemRightClick(ItemStack aStack, World aWorld, EntityPlayer aPlayer);
}