package gregapi.data;

import static gregapi.data.CS.TICKS_PER_SMELT;
import static gregapi.data.TD.Processing.MELTING;
import static gregapi.data.TD.Processing.MORTAR;
import static gregapi.data.TD.Processing.SMITHABLE;
import static gregapi.data.TD.Processing.UNRECYCLABLE;
import static gregapi.data.TD.Properties.*;
import gregapi.oredict.OreDictMaterial;

/**
 * @author Gregorius Techneticies
 */
public class ANY {
	private static OreDictMaterial any(String aNameOreDict) {return OreDictMaterial.createMaterial(-1, aNameOreDict, aNameOreDict).add(UNUSED_MATERIAL, INVALID_MATERIAL, IGNORE_IN_COLOR_LOG);}
	
	/** Technical Materials, which are only there for Recipes and such. */
	public static final OreDictMaterial
	Glowstone		= any("Any Glowstone"		),
	Sapphire		= any("Any Sapphire"		),
	Emerald			= any("Any Emerald"			),
	Grains			= any("Any Grains"			),
	Flour			= any("Any Flour"			),
	Wax				= any("Any Wax"				),
	Wood			= any("Any Wood"			),
	Stone			= any("Any Stone"			),
	Calcite			= any("Any Calcite"			),
	Clay			= any("Any Clay"			),
	Salt			= any("Any Salt"			),
	Fe				= any("Any Iron"			),
	Iron			= any("Any Iron Or Steel"	),
	Steel			= any("Any Iron-Steel"		),
	Cu				= any("Any Copper"			),
	C				= any("Any Carbon"			),
	Coal			= any("Any Coal/Carbon"		),
	Si				= any("Any Silicon"			),
	SiO2			= any("Any Silicon Dioxide"	),
	W				= any("Any Tungsten"		),
	ThaumCrystal	= any("Any Thaumic Crystal"	),
	WoodPlastic		= any("Any Wood Or Plastic"	),
	
	_Steel			= any("Any Steel"			),
	_Bronze			= any("Any Bronze"			),
	_Metal			= any("Any Metal"			);
	
	protected static void init() {
		Glowstone		.stealLooks(MT.Glowstone		).steal(MT.Glowstone	).setLocal("Glowstone"			).setAllToTheOutputOf(MT.Glowstone	).add(CRYSTAL, GLOWING, LIGHTING	).addReRegistrationToThis(MT.Glowstone, MT.GlowstoneCeres, MT.GlowstoneIo, MT.GlowstoneEnceladus, MT.GlowstoneProteus, MT.GlowstonePluto);
		Sapphire		.stealLooks(MT.BlueSapphire		).steal(MT.Sapphire		).setLocal("Sapphire"			).setAllToTheOutputOf(MT.Sapphire	).add(CRYSTAL						).addReRegistrationToThis(MT.Sapphire, MT.Ruby, MT.GreenSapphire, MT.YellowSapphire, MT.OrangeSapphire, MT.BlueSapphire, MT.PurpleSapphire);
		Emerald			.stealLooks(MT.Emerald			).steal(MT.Emerald		).setLocal("Emerald"			).setAllToTheOutputOf(MT.Emerald	).add(CRYSTAL						).addReRegistrationToThis(MT.Emerald, MT.Aquamarine, MT.Morganite, MT.Heliodor, MT.Goshenite, MT.Bixbite, MT.Maxixe, MT.Emeradic);
		Grains			.stealLooks(MT.Wheat			).steal(MT.Wheat		).setLocal("Grains"				).setAllToTheOutputOf(MT.Wheat		).add(FOOD, MORTAR, FLAMMABLE		).addReRegistrationToThis(MT.Wheat, MT.Rye, MT.Oat, MT.Barley, MT.Rice, MT.Corn);
		Flour			.stealLooks(MT.Wheat			).steal(MT.Wheat		).setLocal("Flour"				).setAllToTheOutputOf(MT.Wheat		).add(FOOD, MORTAR, FLAMMABLE		).addReRegistrationToThis(MT.Wheat, MT.Rye, MT.Oat, MT.Barley);
		Wax				.stealLooks(MT.Wax				).steal(MT.Wax			).setLocal("Wax"				).setAllToTheOutputOf(MT.Wax		).add(								).addReRegistrationToThis(MT.Wax, MT.WaxBee, MT.WaxRefractory, MT.WaxParaffin, MT.WaxPlant, MT.WaxMagic);
		Wood			.stealLooks(MT.Wood				).steal(MT.Wood			).setLocal("Wood"				).setAllToTheOutputOf(MT.Wood		).add(WOOD, FLAMMABLE				).addReRegistrationToThis(MT.Wood, MT.WoodSealed, MT.WoodPolished, MT.Peanutwood).setFurnaceBurnTime(TICKS_PER_SMELT/ 2);
		Stone			.stealLooks(MT.Stone			).steal(MT.Stone		).setLocal("Stone"				).setAllToTheOutputOf(MT.Stone		).add(STONE, BRITTLE, UNRECYCLABLE	).addReRegistrationToThis(MT.Stone, MT.Concrete, MT.Gravel, MT.Diorite, MT.Redrock, MT.GraniteBlack, MT.GraniteRed, MT.Limestone, MT.Marble, MT.Basalt, MT.Gabbro, MT.Eclogite, MT.Shale, MT.Andesite, MT.Dacite, MT.Chert, MT.Blueschist, MT.Epidote, MT.Migmatite, MT.Quartzite, MT.Gneiss, MT.Greenschist, MT.Greywacke, MT.Komatiite, MT.Siltstone, MT.Rhyolite, MT.MoonRock, MT.MoonTurf, MT.MarsRock, MT.MarsSand, MT.SpaceRock, MT.Umber);
		Calcite			.stealLooks(MT.CaCO3			).steal(MT.CaCO3		).setLocal("Calcite"			).setAllToTheOutputOf(MT.CaCO3		).add(STONE, BRITTLE, UNRECYCLABLE	).addReRegistrationToThis(MT.CaCO3, MT.Marble, MT.Chalk, MT.Limestone);
		Clay			.stealLooks(MT.ClayBrown		).steal(MT.Clay			).setLocal("Clay"				).setAllToTheOutputOf(MT.Clay		).add(								).addReRegistrationToThis(MT.Clay, MT.ClayBrown);
		Salt			.stealLooks(MT.NaCl				).steal(MT.NaCl			).setLocal("Salt"				).setAllToTheOutputOf(MT.NaCl		).add(BRITTLE						).addReRegistrationToThis(MT.NaCl, MT.KCl, MT.ICl, MT.LiCl, MT.MgCl2, MT.CaCl2);
		Fe				.stealLooks(MT.Fe				).steal(MT.Fe			).setLocal("Iron"				).setAllToTheOutputOf(MT.Fe			).add(SMITHABLE, MELTING			).addReRegistrationToThis(MT.Fe, MT.WroughtIron, MT.PigIron, MT.MeteoricIron, MT.Meteorite, MT.Enori);
		Iron			.stealLooks(MT.Fe				).steal(MT.Fe			).setLocal("Iron"				).setAllToTheOutputOf(MT.Fe			).add(SMITHABLE, MELTING			).addReRegistrationToThis(MT.Fe, MT.WroughtIron, MT.PigIron, MT.MeteoricIron, MT.Meteorite, MT.Enori, MT.Steel, MT.HSLA, MT.Knightmetal, MT.MeteoricSteel);
		Steel			.stealLooks(MT.Steel			).steal(MT.Steel		).setLocal("Steel"				).setAllToTheOutputOf(MT.Steel		).add(SMITHABLE, MELTING			).addReRegistrationToThis(MT.Steel, MT.HSLA, MT.Knightmetal, MT.MeteoricSteel);
		Cu				.stealLooks(MT.Cu				).steal(MT.Cu			).setLocal("Copper"				).setAllToTheOutputOf(MT.Cu			).add(SMITHABLE, MELTING			).addReRegistrationToThis(MT.Cu, MT.AnnealedCopper);
		C				.stealLooks(MT.C				).steal(MT.C			).setLocal("Carbon"				).setAllToTheOutputOf(MT.C			).add(								).addReRegistrationToThis(MT.C, MT.Graphite, MT.Graphene);
		Coal			.stealLooks(MT.C				).steal(MT.C			).setLocal("Carbon"				).setAllToTheOutputOf(MT.C			).add(								).addReRegistrationToThis(MT.C, MT.Graphite, MT.Graphene, MT.CoalCoke, MT.Coal, MT.Charcoal);
		Si				.stealLooks(MT.Si				).steal(MT.Si			).setLocal("Silicon"			).setAllToTheOutputOf(MT.Si			).add(SMITHABLE, MELTING			).addReRegistrationToThis(MT.Si);
		SiO2			.stealLooks(MT.SiO2				).steal(MT.SiO2			).setLocal("Silicon Dioxide"	).setAllToTheOutputOf(MT.SiO2		).add(BRITTLE, MELTING				).addReRegistrationToThis(MT.SiO2, MT.Glass, MT.Flint, MT.NetherQuartz, MT.Quartzite, MT.CertusQuartz, MT.ChargedCertusQuartz, MT.SunnyQuartz, MT.SmokeyQuartz, MT.LavenderQuartz, MT.ManaQuartz, MT.RedQuartz, MT.ElvenQuartz, MT.BlazeQuartz);
		W				.stealLooks(MT.W				).steal(MT.W			).setLocal("Tungsten"			).setAllToTheOutputOf(MT.W			).add(SMITHABLE, MELTING			).addReRegistrationToThis(MT.W, MT.TungstenSintered);
		ThaumCrystal	.stealLooks(MT.InfusedBalance	).steal(MT.InfusedDull																		).add(DONT_SHOW_THIS_COMPONENT		).addReRegistrationToThis(MT.InfusedDull, MT.InfusedVis, MT.InfusedOrder, MT.InfusedEntropy, MT.InfusedAir, MT.InfusedWater, MT.InfusedEarth, MT.InfusedFire, MT.InfusedBalance);
		WoodPlastic		.stealLooks(MT.Wood				).steal(MT.Wood																				).add(DONT_SHOW_THIS_COMPONENT		).addReRegistrationToThis(MT.Wood, MT.WoodSealed, MT.WoodPolished, MT.Peanutwood, MT.Plastic);
		
		_Steel			.stealLooks(MT.Steel			).add(DONT_SHOW_THIS_COMPONENT);
		_Bronze			.stealLooks(MT.Bronze			).add(DONT_SHOW_THIS_COMPONENT);
		_Metal			.stealLooks(MT.Fe				).add(DONT_SHOW_THIS_COMPONENT);
	}
}